HDU 1800-Flying to the Mars(trie树)

来源:互联网 发布:大非农数据是什么意思 编辑:程序博客网 时间:2024/06/05 19:34
E - Flying to the Mars
Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u
Submit Status Practice HDU 1800
Appoint description: 

Description


In the year 8888, the Earth is ruled by the PPF Empire . As the population growing , PPF needs to find more land for the newborns . Finally , PPF decides to attack Kscinow who ruling the Mars . Here the problem comes! How can the soldiers reach the Mars ? PPF convokes his soldiers and asks for their suggestions . “Rush … ” one soldier answers. “Shut up ! Do I have to remind you that there isn’t any road to the Mars from here!” PPF replies. “Fly !” another answers. PPF smiles :“Clever guy ! Although we haven’t got wings , I can buy some magic broomsticks from HARRY POTTER to help you .” Now , it’s time to learn to fly on a broomstick ! we assume that one soldier has one level number indicating his degree. The soldier who has a higher level could teach the lower , that is to say the former’s level > the latter’s . But the lower can’t teach the higher. One soldier can have only one teacher at most , certainly , having no teacher is also legal. Similarly one soldier can have only one student at most while having no student is also possible. Teacher can teach his student on the same broomstick .Certainly , all the soldier must have practiced on the broomstick before they fly to the Mars! Magic broomstick is expensive !So , can you help PPF to calculate the minimum number of the broomstick needed . 
For example : 
There are 5 soldiers (A B C D E)with level numbers : 2 4 5 6 4; 
One method : 
C could teach B; B could teach A; So , A B C are eligible to study on the same broomstick. 
D could teach E;So D E are eligible to study on the same broomstick; 
Using this method , we need 2 broomsticks. 
Another method: 
D could teach A; So A D are eligible to study on the same broomstick. 
C could teach B; So B C are eligible to study on the same broomstick. 
E with no teacher or student are eligible to study on one broomstick. 
Using the method ,we need 3 broomsticks. 
…… 

After checking up all possible method, we found that 2 is the minimum number of broomsticks needed. 
 

Input

Input file contains multiple test cases. 
In a test case,the first line contains a single positive number N indicating the number of soldiers.(0<=N<=3000) 
Next N lines :There is only one nonnegative integer on each line , indicating the level number for each soldier.( less than 30 digits); 
 

Output

For each case, output the minimum number of broomsticks on a single line.
 

Sample Input

410203004523434
 

Sample Output

12
 

思路:

  这题Wa成狗了,都是数组惹的祸。。。。
  这题设计的不错,竟然有点数学的味道,它要找最小的教的队数,所以只要找到最多相同的lv就是最小要几个队。

AC代码:

/*这题wa了十几次,一开始开数组太大,无法写在结构体里,所以将它从里面拿出来了,结果一直wa,最后看了看题解,原来只有3000左右,他是不会超过3000个节点的。*/#include<iostream>#include<algorithm>#include<cstring>#include<cstdio>#include<vector>#include<queue>#include<cmath>typedef long long ll;using namespace std;#define T 3005#define maxn 10#define inf 0x3f3f3f3fstruct trie{int kid[T][10],v[T];int root,L;int ma;int ans(){return ma;}trie(){ma = 0;root = 0;L = 1;memset(kid[0],-1,sizeof(kid[0]));}int newnode(){v[L]=0;memset(kid[L],-1,sizeof(kid[L]));return L++;}void insert(char* s){int p = root;for(int i=0;s[i];++i){int d=s[i]-'0';if(kid[p][d]==-1){kid[p][d] = newnode();}p = kid[p][d];}v[p]++;ma = max(ma,v[p]);}};int main(){#ifdef zsc freopen("input.txt","r",stdin);#endif int n,i,j; char str[50]; while(~scanf("%d",&n)) { trie tr; for(i=0;i<n;++i){ scanf("%s",&str); int c = 0; while(str[c++]=='0'); for(j=0,c--;str[c];++c){ str[j++] = str[c]; }str[j] = '\0'; if(str[0]=='\0')str[0]='0',str[1]='\0'; tr.insert(str); } printf("%lld\n",tr.ans()); }    return 0;}


0 0
原创粉丝点击